//
//
//
let host;
try {
    // eslint-disable-next-line no-restricted-globals
    host = parent; // do not use check `typeof parent` due to IE11 "Access denied error", instead wrap by try/catch
}
catch (e) {
    host = {}; // use mocked host object when running in node (e2e tests)
}
const receivers = [];
let config = {
    product: "",
    validReceivedPostEvents: [],
};
const receiveListener = (listener) => (event) => {
    return event?.data?.gdc?.product === config.product &&
        // check for valid incoming command
        config.validReceivedPostEvents.includes(event?.data?.gdc?.event?.name)
        ? listener(event)
        : false;
};
//
//
//
/**
 * Set post message target - useful for unit tests.
 *
 * @internal
 */
export const setHost = (h) => {
    host = h;
};
/**
 * @internal
 */
export function setConfig(product, validReceivedPostEvents) {
    config = { product, validReceivedPostEvents };
}
/**
 * @internal
 */
export function addListener(listener, target = window) {
    const receiver = receiveListener(listener);
    receivers.push({ listener, receiver });
    target.addEventListener("message", receiver, false);
}
/**
 * @internal
 */
export function removeListener(listener, target = window) {
    const receiverObj = receivers.find((r) => r.listener === listener);
    if (receiverObj) {
        receivers.splice(receivers.indexOf(receiverObj), 1);
        target.removeEventListener("message", receiverObj.receiver);
    }
}
/**
 * @internal
 */
export function postEvent(product, name, data, contextId) {
    if (!host.postMessage) {
        return;
    }
    host.postMessage({
        gdc: {
            product,
            event: { name, data, contextId },
        },
    }, "*");
}
//# sourceMappingURL=messagingUtils.js.map